View Issue Details

IDProjectCategoryView StatusLast Update
0001906WishesEditorpublic2016-01-17 13:45
ReporterMaximusAssigned To2useven10 
PrioritynormalSeverityfeatureReproducibilityhave not tried
Status closedResolutionfixed 
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0001906: Не удается скопировать строку, содержащую \0
DescriptionЗадача - сделать дубль строки, макросом. Если строка содержит \0 - копия обрезается.
Через Editor.Value - не получится. Он содержит строку до первого \0.
Через буфер
а) виндовый - тоже не получится, строка обрезается, ограничения WinAPI
б) внутренний - не получается, хотя вполне можно было бы.

Да и через виндовый буфер тоже можно бы, если в Clipboard дополнительно добавлять данные во внутреннем формате фара, и хранить там еще и
{CodePage}{DataSize?}{BinaryData}

Тогда и макрос (переключения на внутренний буфер) не понадобился бы.
Steps To ReproduceОткрыть какой-нибудь файл с \0. Например, файл в кодировке 1200 открыть в кодировке 866. Скорее всего в первой же строке будут \0

Макрос:

clip(5,2) // внутренний буфер
%pos = editor.pos(0,2);
CtrlU Home ShiftDown CtrlIns CtrlU ShiftIns Up
editor.pos(1,2,%pos)
TagsNo tags attached.
Build4496

Activities

vskirdin

2012-01-10 16:16

administrator   bugnote:0008347

хмм... помысли - а ведь и Undo/Redo в редакторе не будет пахать...
хмм... и не только ундо-редо: везде юзается StrLength - суть которому wcslen(str)
дофига переделывать...

JohnDoe

2012-02-13 18:36

updater   bugnote:0008557

А зачем может понадобиться копировать строку с \0

Maximus

2012-02-13 21:12

reporter   bugnote:0008563

я же в тикете написал.
любой файл, в котором есть \0
фар "не справится" с его редактированием
причины появления могут варьироваться - от кривых рук автора, до смешанных кодировок или бинарных файлов.

JohnDoe

2012-02-14 01:46

updater   bugnote:0008566

Т.е. в основном для редактирования бинарных файлов.

2useven10

2015-12-29 14:13

developer   bugnote:0014182

4496

Issue History

Date Modified Username Field Change
2011-10-16 03:38 Maximus New Issue
2012-01-10 16:16 vskirdin Note Added: 0008347
2012-01-11 02:56 alexy Project Far Manager => Wishes
2012-02-13 18:36 JohnDoe Note Added: 0008557
2012-02-13 21:12 Maximus Note Added: 0008563
2012-02-14 01:46 JohnDoe Note Added: 0008566
2013-02-03 04:31 alexy Severity minor => feature
2015-12-29 14:13 2useven10 Note Added: 0014182
2015-12-29 14:13 2useven10 Assigned To => 2useven10
2015-12-29 14:13 2useven10 Status new => feedback
2016-01-17 13:45 2useven10 Build => 4496
2016-01-17 13:45 2useven10 Status feedback => closed
2016-01-17 13:45 2useven10 Resolution open => fixed
2016-01-17 13:45 2useven10 Fixed in Version => 3.0